/**
 * @OpenDialog.java     13.07.2010
 * build: 13.07.2010
 * Copyright 2010 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 *
 * This file is a part of SchiebePuzzle
 * Spiele is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * SchiebePuzzle is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with Spiele;
 * if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 */
package de.yourwebs.schiebepuzzle;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;

import javax.swing.JDialog;
import javax.swing.JFileChooser;

/**
 * 
 */
@SuppressWarnings("serial")
public class OpenDialog extends JDialog {

	private File inputVerzFile;

	private String inputVerzString;

	private JFileChooser chooser;

	public OpenDialog(final SchiebePuzzleGUI parentComp) {
		super();
		chooser = new JFileChooser();
		chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		chooser.setDialogType(JFileChooser.OPEN_DIALOG);

		chooser.addChoosableFileFilter(new BildFilter());

		chooser.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {

				if (e.getPropertyName().equals(
						JFileChooser.SELECTED_FILE_CHANGED_PROPERTY)
						|| e.getPropertyName().equals(
								JFileChooser.DIRECTORY_CHANGED_PROPERTY)) {
					final File f = (File) e.getNewValue();
					if (f != null) {
						inputVerzFile = f;
						inputVerzString = f.toString();

					}
				}
			}
		});

		this.setTitle("Bild laden");

		chooser.setSelectedFile(inputVerzFile);
		chooser.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				inputVerzFile = chooser.getSelectedFile();
				if (inputVerzFile != null
						&& e.getActionCommand().equals(
								JFileChooser.APPROVE_SELECTION)) {
					inputVerzString = inputVerzFile.getPath();
					if (inputVerzString != null)
						parentComp.setExtImg(inputVerzString);
				}
				OpenDialog.this.setVisible(false);
				OpenDialog.this.dispose();
			}
		});

		this.add(chooser, BorderLayout.CENTER);
		this.pack();
		this.setAlwaysOnTop(true);
		this.setLocationRelativeTo(null);
		this.setVisible(true);
	} // Ende Konstruktor
}
