/**
 * @SchiebeElement.java     19.07.2010
 * build: 19.07.2010
 * Copyright 2010 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 *
 * This file is a part of Schiebepuzzle
 * Schiebepuzzle is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * Spiele is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with Spiele;
 * if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 */
package de.yourwebs.schiebepuzzle;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

/**
 * Puzzleelements (squares) that can be pushed from one to another place
 * 
 */
public class SchiebeElement extends JPanel {

	private static final long serialVersionUID = 1L;
	protected JLabel label;

	public SchiebeElement(JPanel panel) {
		int rectSize = panel.getWidth() / SchiebePuzzleGUI.elements;
		this.setPreferredSize(new Dimension(rectSize, rectSize));
		this.setSize(new Dimension(rectSize, rectSize));
		this.setBorder(new LineBorder(Color.WHITE));
		this.setOpaque(true);
		this.setLayout(new GridLayout(1, 1));
		label = new JLabel("", JLabel.CENTER);
		this.add(label);
	} // Konstruktor
}

class ImageElement extends SchiebeElement {

	private static final long serialVersionUID = 1L;

	public ImageElement(JPanel panel) {
		super(panel);
	}

	public void setImage(ImageIcon icon) {
		label.setIcon(icon);
	}
}

class NumberElement extends SchiebeElement {

	private static final long serialVersionUID = 1L;

	public NumberElement(JPanel panel, int number) {
		super(panel);
		Font font = new Font("Verdana", Font.BOLD, SchiebePuzzleGUI.fontSize);
		label.setFont(font);
		label.setText(Integer.valueOf(number).toString());
		label.setSize(this.getWidth(), this.getHeight());
		add(label);
	}
}
